Index: pobysoPythonSage/src/sageSLZ/sagePolynomialOperations.sage
===================================================================
--- pobysoPythonSage/src/sageSLZ/sagePolynomialOperations.sage	(revision 77)
+++ pobysoPythonSage/src/sageSLZ/sagePolynomialOperations.sage	(revision 78)
@@ -25,17 +25,16 @@
     # We work from p^0 * N^alpha to p^alpha * N^0
     for pPower in xrange(0, alpha + 1):
         # pPower == 0 is a special case. We introduce all the monomials but one
-        # in, those in t necessary to be able to introduce
+        # in i and those in t necessary to be able to introduce
         # p. We arbitrary choose to introduce the highest degree monomial in i
         # with p. We also introduce all the mixed i^k * t^l monomials with
         # k < p.degree(i) and l <= p.degree(t).
-        # Mixed terms introduction is necessary before we start "i shifts" in
-        # the next iteration.
+        # Mixed terms introduction is necessary here before we start "i shifts"
+        # in the next iteration.
         if pPower == 0:
-            # iter1: power of i
-            # Notice how i^pIdegree is excluded.
+            # Notice that i^pIdegree is excluded as the bound of the xrange is
+            # pIdegree
             for iPower in xrange(0, pIdegree): 
-                # iter5: power of t.
                 for tPower in xrange(0, pTdegree + 1):
                     if columnsWidth != 0:
                         print "->", spo_expression_as_string(iPower, 
@@ -44,8 +43,8 @@
                                                              alpha)
                     currentExpression = iVariable^iPower * \
                                         tVariable^tPower * nAtPower
-                    # polynomialAtPower == 1 here. Next line should be commented out but it does not work!
-                    # Some convertion problem?
+                    # polynomialAtPower == 1 here. Next line should be commented
+                    # out but it does not work! Some conversion problem?
                     currentPolynomial = pRing(currentExpression) * \
                                         polynomialAtPower 
                     pMonomials = currentPolynomial.monomials()
@@ -55,11 +54,10 @@
                                                         knownMonomials, 
                                                         protoMatrixRows, 
                                                         columnsWidth)
-                # End iter5.
-            # End for iter1.
-            
+                # End tPower.
+            # End for iPower.
         else: # pPower > 0: (p^1..p^alpha)
-            # This where we introduce the p^iPower * N^(alpha-iPower)
+            # This where we introduce the p^pPower * N^(alpha-pPower)
             # polynomial.
             # This step could technically be fused as the first iteration
             # of the next loop (with iPower starting at 0).
@@ -97,7 +95,7 @@
             # We want now to introduce a t * p^pPower polynomial. But before
             # that we must introduce some mixed monomials.
             # This loop is no triggered before pPower == 2.
-            # It introduces a first set of mixed monomials.
+            # It introduces a first set of high i degree mixed monomials.
             for iPower in xrange(1, pPower):
                 tPower = pPower - iPower + 1
                 if columnsWidth != 0:
@@ -115,13 +113,16 @@
                                                     protoMatrixRows, 
                                                     columnsWidth)
             # End for iPower
-            # This is the main loop. It introduces:
+            #
+            # This is the mixed monomials main loop. It introduces:
             # - the missing mixed monomials needed before the 
-            #   t * p^pPower * N^(alpha-pPower)  polynomial;
-            # - the t * p^pPower * N^(alpha-pPower) itself;
-            # - the missing mixed monomials needed before each of the 
-            #   i^k * t^l * p^pPower * N^(alpha-pPower) polynomials;
-            # - the i^k * t^l * p^pPower * N^(alpha-pPower) themselves.
+            #   t^l * p^pPower * N^(alpha-pPower) polynomial;
+            # - the t^l * p^pPower * N^(alpha-pPower) itself;
+            # - for each of i^k * t^l * p^pPower * N^(alpha-pPower) polynomials:
+            #   - the the missing mixed monomials needed  polynomials,
+            #   - the i^k * t^l * p^pPower * N^(alpha-pPower) itself.
+            # The t^l * p^pPower * N^(alpha-pPower) is introduced when
+            # 
             for iShift in xrange(0, pIdegree):
                 # When pTdegree == 1, the following loop only introduces 
                 # a single new monomial.
@@ -144,15 +145,18 @@
                                                         protoMatrixRows, 
                                                         columnsWidth)
                     #print "+++++"
-
-                    # At iShift == 0, the following loop adds duplicate 
-                    # monomials, since no extra i^l * t^k is needed before 
-                    # introducing the  
+                    # At iShift == 0, the following innerTpower loop adds  
+                    # duplicate monomials, since no extra i^l * t^k is needed 
+                    # before introducing the  
                     # i^iShift * t^outerPpower * p^pPower * N^(alpha-pPower) 
                     # polynomial.
                     # It introduces smaller i degree monomials than the
                     # one(s) added previously (no pPower multiplication).
                     # Here the exponent of t decreases as that of i increases.
+                    # This conditional is not entered before pPower == 1.
+                    # The innerTpower loop does not produce anything before
+                    # pPower == 2. We keep it anyway for other configuration of
+                    # p.
                     if iShift > 0:
                         iPower = pIdegree + iShift
                         for innerTpower in xrange(pPower, 1, -1):
@@ -174,6 +178,12 @@
                             iPower += pIdegree
                         # End for innerTpower
                     # End of if iShift > 0
+                    # When iShift == 0, just after each of the  
+                    # p^pPower * N^(alpha-pPower) polynomials has 
+                    # been introduced (followed by a string of 
+                    # i^k * p^pPower * N^(alpha-pPower) polynomials) a
+                    # t^l *  p^pPower * N^(alpha-pPower) is introduced here.
+                    # 
                     # Eventually, the following section introduces the 
                     # i^iShift * t^outerTpower * p^iPower * N^(alpha-iPower) 
                     # polynomials.
@@ -193,8 +203,6 @@
                                                         columnsWidth)
                 # End for outerTpower 
                 #print "++++++++++"
-
-
             # End for iShift
         polynomialAtPower *= p  
         nAtPower /= N
@@ -221,7 +229,7 @@
     protoMatrixRows: a list of lists, each one holding the coefficients of the 
                      monomials
     columnWith     : the width, in characters, of the displayed column ; if 0, 
-                     do display anything.
+                     do not display anything.
     """
     # We have started with the smaller degrees in the first variable.
     pMonomials.reverse()
